package zephyr.sanshusha.accessdejp;

import java.util.regex.Matcher;

import zephyr.util.AppendLatinKeys;
import zephyr.util.UnescapeChars;
import zephyr.util.ZephyrUtil;

public class AppendDeKeys extends AppendLatinKeys {

    protected String parse(String line, String type) {
        line = UnescapeChars.unescape(line);
        String line2 = line.replaceAll("<b>[0-9I]+</b>", "").replace("<b>", "").replace("</b>", "");
        Matcher m = DT_DD.matcher(line2);
        if (!m.find()) {
            return line;
        }
        String dt = m.group(1);
        String dd = m.group(3);
        String keys = makeKeys(dt, dd, WORD, type);
        int idx = line.indexOf("<dd>");
        return line.substring(0, idx) + keys + line.substring(idx);
    }

    public static void main(String[] args) {
        if (args.length < 2) {
            System.err.println("Usage: java AppendDeKeys body-dejp.html [表記|条件]");
            return;
        }

        ZephyrUtil.setUTF8Ouput();
        AppendDeKeys app = new AppendDeKeys();
        try {
            app.appendKeys(args);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
